call SetFrameRate(100)
call IntensitySprite(100)
textSize = {40,5}
call TextSizeSprite(textSize)
version = Version()
if version = 100 then
instructions = {{-80,90,"YOU HAVE VECTREX32 1.00."},{-80,70,"TO UPGRADE,GO TO"},_
{-80,60,"VECTREX32.COM AND"},_
{-80,50,"CONTACT US"}}
call TextListSprite(instructions)
while true
call WaitForFrame(JoystickNone,Controller1,JoystickNone)
endwhile
else
versionNumber = version / 100 + "." + TwoDigits(version mod 100)
newVersion = ""
files = Dir()
for i = 1 to UBound(files)
if StrComp(".v32",Right(files[i],4),1) = 0 then
newVersion = Mid(files[i],11,4)
exit for
endif
next i
if newVersion = "" then
instructions = {{-80,90,"CAN'T FIND A .V32"},{-80,80,"UPGRADE FILE."}}
sprite = TextListSprite(instructions)
while true
call WaitForFrame(JoystickNone,Controller1,JoystickNone)
endwhile
endif
instructions = {{-80,90,"YOU HAVE VECTREX32 " + versionNumber + "."},_
{-80,70,"TO UPGRADE TO " + newVersion + ","},_
{-80,60,"PRESS BUTTON 1."},_
{-80,50,"THE SCREEN WILL GO"},_
{-80,40,"BLACK FOR UP TO 30"},_
{-80,30,"SECONDS. PLEASE WAIT."}}
sprite = TextListSprite(instructions)
checksumHighFlash = 0x9d1f0000
expectedChecksumHighFlash = 0x9d1f0100
undoUpgrade = 0x9d1f0200
done = false
while true
controls = WaitForFrame(JoystickNone,Controller1,JoystickNone)
if controls[1,3] and not done then
call Upgrade(1)
call RemoveSprite(sprite)
if JSR(checksumHighFlash) = JSR(expectedChecksumHighFlash) then
instructions = {{-80,90,"UPGRADE COMPLETE!"},_
{-80,70,"TURN THE VECTREX"},_
{-80,60,"OFF AND ON."}}
sprite = TextListSprite(instructions)
done = true
else
if version < 116 then
bfe = {0x9d0ebd04,0x9d0ec830,0x9d0ec844,0x9d0f58b4,0x9d0e866c,0x9d0e83ec}
call jsr(bfe[version - 109])
endif
instructions = {{-80,90,"UPGRADE FAILED!"},_
{-80,70,"PRESS BUTTON 1"},_
{-80,60,"TO RETRY."}}
sprite = TextListSprite(instructions)
endif
endif
endwhile
endif
function TwoDigits(x)
if x < 10 then
return "0" + x
else
return "" + x
endif
endfunction
